dosseg

.model medium
assume es:nothing

include se.asm

public InitSound, DoneSound, SetBasePort, InitSample, SetSound, GetRate

public KeyPressed, ReadKey

public InitKBD, DoneKBD, KBOn, KBOff, KBuf, SetLEDs, WriteKBD

public SCWrite, NumPad

public SetRGB, WaitRetrace

public ABSOLUTE

public F_PADD@, F_PADA@, F_LXLSH@

; DECLARE SUB ABSOLUTE (address AS INTEGER)

; declare function KBuf%(byval a%)
; declare sub InitKBD()
; declare sub DoneKBD()
; declare sub KbOn()
; declare sub KbOff()

; declare function KeyPressed%()
; declare function ReadKey%()

; declare function SetLEDs%(byval a%)
; declare sub WriteKBD(byval a%)

; declare function InitSound%()    - returns 0 if ok
; declare sub DoneSound()
; declare sub SetBasePort(byval a%)
; declare sub InitSample(byval SmpNum%, byval Index%, byval Value%)
; declare sub SetSound(byval Chan%, byval Herz%, byval Volume%)
; declare function GetRate%()

; DECLARE SUB SCWrite (BYVAL Offs%, BYVAL c%, s$)
; DECLARE SUB NumPad (Dest$, byval Num%, byval MaxLen%)

; declare sub SetRGB(byval c%, byval r%, byval g%, byval b%)
; declare sub WaitRetrace()

extrn b$seg : word

.code

.386c

ScrollerInit:
        retf

SetRGB: arg c, byte, 2
        arg r, byte, 2
        arg g, byte, 2
        arg b, byte, 2
        entry far
         mov dx, 3C8h
         mov al, c
         out dx, al
         inc dx
         mov al, r
         out dx, al
         mov al, g
         out dx, al
         mov al, b
         out dx, al
        exit

Buf     db 8 dup (?)
N10     dw 10
NumPad: arg Dest, word, 1
        arg Num,  word, 1
        arg Max,  word, 1
        entry far

        push si
        push di
         mov Buf.b5, -48

         mov cx, Max
         jcxz @@4

         mov cx, Num

         mov bx, 10000
         mov ax, cx
         xor dx, dx
         div bx
         mov Buf.b0, al

         mov bx, 1000
         mov ax, cx
         xor dx, dx
         div bx
         xor dx, dx
         div N10
         mov Buf.b1, dl

         mov bx, 100
         mov ax, cx
         xor dx, dx
         div bx
         xor dx, dx
         div N10
         mov Buf.b2, dl

         mov ax, cx
         xor dx, dx
         div N10
         xor dx, dx
         div N10
         mov Buf.b3, dl

         mov ax, cx
         xor dx, dx
         div N10
         mov Buf.b4, dl

         mov di, Dest
         mov di, [di+2]

         xor si, si
         mov cx, 5
@@1:     cmp byte ptr Buf[si], 0
         jne @@2
         inc si
         loop @@1

@@2:     mov cx, Max         
@@3:     mov al, Buf[si]
         add al, 48
         jz @@4
         mov [di], al
         inc si
         inc di
         loop @@3

@@4:    pop di
        pop si

        exit

SCWrite:arg Offs, word, 1
        arg Color, word, 1
        arg Str, word, 1
        entry far

        push si
        push di
        push es

        mov si, Str

        mov cx, [si+0]
        mov si, [si+2]

        mov di, Offs

        mov ax, 0B800h
        mov es, ax

        mov ah, Color.b0

        jcxz @@2
@@1:    mov al, [si]
        inc si
        mov es:[di], ax
        add di, 2
        loop @@1
@@2:

        pop es
        pop di
        pop si
        exit

Rate    dw 22050

Ticks   dw ?
Counter dw ?
BasePort dw 220h

        even
Herz    dd ?, ?, ?, ?, ?, ?, ?, ?
Pos     dd ?, ?, ?, ?, ?, ?, ?, ?
Volume  db ?, ?, ?, ?, ?, ?, ?, ?

        even
SmpData dw (2048*3) dup (?)

GetRate:mov ax, Rate
        retf

SetSound:
        arg Chan1, word, 1
        arg Herz1, word, 1
        arg Volume1, word, 1
        entry far
         mov ax, Chan1
         cmp ax, 8
         jae @@9
         add ax, ax
         add ax, ax
         mov di, ax

         movzx edx, Herz1
         mov dx, 8   ;512k
         xor ax, ax
         div Rate
         mul Herz1
         mov Herz[di].w0, ax
         mov Herz[di].w2, dx

         mov ax, Volume1
         cmp ax, 255
         jle @@1
         mov ax, 255
@@1:     cmp ax, 0
         jge @@2
         xor ax, ax
@@2:     mov di, Chan1
         mov Volume[di], al
@@9:    exit

SetBasePort:
        arg PortNum, word, 1
        entry far
         mov ax, PortNum
         mov BasePort, ax
        exit

NewI08: push eax
         ;jmp @@SKIP_I08
         push di
         push si
         push bx
         push edx
         push ecx

         xor di, di
         xor bx, bx
         xor ecx, ecx

@@NEXTCHAN:
         mov dl, byte ptr Volume[di]
         or dl, dl
         jz @@MUTE

         mov si, di
         shl si, 2

         mov eax, Herz[si]
         add Pos[si], eax

         mov ax, word ptr Pos[si+1]
         and ax, 2047
         add ax, ax

         mov si, ax
         add si, bx
         mov ax, SmpData[si]

         xor dh, dh
         mul dx
         shl edx, 16
         mov dx, ax
         add ecx, edx

@@MUTE:  or di, di
         jz @@SKIPSAMPLECHANGE
         cmp di, 3
         jb @@EIVAKIO
         xor bx, bx
         jmp @@SKIPSAMPLECHANGE
@@EIVAKIO:
         add bx, 2048*2
@@SKIPSAMPLECHANGE:
         inc di
         cmp di, 8
         jb @@NEXTCHAN
         
         shr ecx, 5       ;Write out the sample
         mov al, ch

         pop ecx
         pop edx
         pop bx
         pop si
         pop di

         call WriteDAC

@@SKIP_I08:
         mov ax, Ticks
         add Counter, ax
         jnc DoIret
        pop eax
db      0EAh
OldI08  dd ?
DoIret:  mov al, 20h
         out 20h, al
        pop eax
        iret

InitSound:
        xor eax, eax
        mov dword ptr Volume[0], eax
        mov dword ptr Volume[4], eax

        mov ax, 3508h
        int 21h
        mov OldI08.Ofs, bx
        mov OldI08.Seg, es

        call InitDSP
        or ax, ax
        jnz @@1

        mov ax, 1
        retf

@@1:    mov dx, 12h
        mov ax, 34DCh
        div Rate
        mov Counter, ax

        push ds
         mov ax, 2508h
         push cs
         pop ds
         mov dx, offset NewI08
         int 21h
        pop ds

        mov al, 34h
        out 43h, al

        mov al, Counter.b0
        out 40h, al
        mov al, Counter.b1
        out 40h, al

        xor ax, ax

        retf

DoneSound:
        mov al, 34h
        out 43h, al
        xor ax, ax
        out 40h, al
        out 40h, al

        push ds
         mov ax, 2508h
         mov dx, OldI08.Ofs
         mov ds, OldI08.Seg
         int 21h
        pop ds

        call DoneDSP

        retf

; declare sub InitSample(byval SmpNum%, byval Index%, byval Value%)
InitSample:
        arg SmpNum, word, 1
        arg Index, word, 1
        arg Value, word, 1
        entry far
         mov bx, SmpNum
         cmp bx, 3
         jae @@1

         shl bx, 12     ;*2048*2

         mov ax, Index
         cmp ax, 2048
         jae @@1

         mov di, ax
         add di, ax

         mov ax, Value
         mov word ptr SmpData[bx+di], ax

@@1:    exit

WriteDSP:
         push dx
          push ax
           mov dx, BasePort
           add dx, 00Ch
      @@1: in al, dx
           or al, al
           js @@1
          pop ax
          out dx, al
         pop dx
        retn

ReadDSP:
        push dx
         mov dx, BasePort
         add dx, 00Eh
     @@1:in al, dx
         or al, al
         jns @@1
         mov dx, BasePort
         add dx, 00Ah
         in al, dx
        pop dx
        retn

WriteDAC:
        push ax
         mov al, 10h
         call WriteDSP
        pop ax
        call WriteDSP
        retn

BitDelay:
        push cx
        xor cx,cx
    @@1:loop @@1
        pop cx
        retn
  
InitDSP:
        push dx
         mov dx, BasePort
         add dl, 6
         mov al, 1
         out dx, al
         call BitDelay
         dec ax
         out dx, al
         call BitDelay
         add dl, 8
         in al, dx
         and al, 80h
         jz @@1
         sub dl, 4
         in al, dx
         cmp al, 0AAh
         je @@2
         xor al, al
         jmp @@1
     @@2:mov al, 0D1h
         call WriteDSP
         mov al, 1
     @@1:
        pop dx
        xor ah, ah
        retn

DoneDSP:
        mov al,0D3h
        call WriteDSP
        call WriteDSP
        retn

ScanCode db 0

KeyPressed:
        cmp ScanCode, 0
        jnz @@2
        mov ah, 11h
        int 16h
        mov ax, 0
        jz @@1
@@2:    mov ax, 1
@@1:    retf

ReadKey:xor al, al
        xchg al, ScanCode
        test al, al
        jz @@1
        jmp @@2
@@1:    xor ax, ax
        int 16h
        test al, al
        jnz @@2
        mov ScanCode, ah
@@2:    xor ah, ah
        retf

        even
KBuffi  db 128 dup (?)
IsKbOn  db ?

;KB_Act  db 0,1,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,1,0,0,0, 0,0,0,0,0,0,0,0
;        db 1,0,0,0,1,0,0,0, 1,0,0,0,1,0,0,0, 1,0,0,1,0,0,1,0, 0,1,0,0,1,0,0,1
;        db 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0
;        db 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0
;
;        db 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0, 1,0,1,0,1,0,1,0
;        db 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0
;        db 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0
;        db 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0, 1,1,1,0,1,1,1,0

KBuf:   arg a, word, 1
        entry far
         xor ax, ax
         mov bx, a
         cmp bx, 255
         ja @@1
         and bx, 127
         or al, byte ptr KBuffi[bx]
         jz @@1
         mov al, 255
         ;cmp al, 255
         ;je @@1
         ;inc byte ptr KBuffi[bx]
         ;test byte ptr a, 128
         ;jnz @@1
         ;mov al, 1
         ;mov bx, offset KB_Act
         ;segcs xlat
@@1:    exit

GotAck  db 0    ; ACK
GotErr  db 0    ; RESEND
GotInvk db 0    ; Liian monta nappia pohjassa
GotBat  db 0    ; BAT (eli 0AAh)
GotEcho db 0    ; ECHO (eli 0EEh)

NewI09: push eax
         in al, 60h
         cmp al, 0AAh
         je @@BAT
         cmp al, 0EEh
         je @@ECHO
         cmp al, 0FAh
         je @@ACK
         cmp al, 0FEh
         je @@ERR
         cmp al, 0FFh
         je @@INVK
         cmp al, 0
         jz @@INVK
         cmp al, 0E0h
         jae @@R
         cmp al, 055h
         je @@R
         xor ah, ah
         push bx
          mov bx, ax
          and bx, 127
          shr ax, 7
          xor al, 1
          cmp al, 0
          je @@1
          cmp byte ptr KBuffi[bx], 0
          jne @@2
@@1:      mov byte ptr KBuffi[bx], al
@@2:     pop bx
@@Q:     cmp IsKBOn, 0
         jne DoIret
@@R:    pop eax
        jmp @@RET
@@BAT:  mov GotBat, 1
        jmp @@Q
@@ECHO: mov GotEcho, 1
        jmp @@Q
@@ACK:  mov GotAck, 1
        jmp @@Q
@@ERR:  mov GotErr, 1
        jmp @@Q
@@INVK: mov GotInvk, 1
        jmp @@Q
@@RET:  db 0EAh
OldI09  dd ?

InitKBD:mov ax, 3509h
        int 21h
        mov OldI09.Ofs, bx
        mov OldI09.Seg, es

        mov IsKbOn, 0

        push ds
         mov ax, 2509h
         push cs
         pop ds
         mov dx, offset NewI09
         int 21h
        pop ds

        mov di, offset KBuffi
        mov cx, 128
        xor al, al
@@1:    mov cs:[di], al
        inc di
        loop @@1

        retf

DoneKBD:push ds
         mov ax, 2509h
         mov dx, OldI09.Ofs
         mov ds, OldI09.Seg
         int 21h
         mov ax, 40h
         mov ds, ax
         mov word ptr ds:[17h], 0
        pop ds
        retf

KbOn:   mov IsKbOn, 1
        retf
        
KbOff:  mov IsKbOn, 0
        retf

WriteKBD:
        arg Tavu, byte, 2
        loc Yritys, word, 1
        loc x,      word, 1
        entry far

        mov Yritys, 3
        mov x, 0
@@1:     mov GotAck, 0
         mov GotErr, 0
         mov cx, 32000
@@3:     in al, 64h
         test al, 2
         jz @@2
         loop @@3
@@2:     mov al, Tavu
         out 60h, al
         mov cx, 1000
          pushf
          push cs
          call near ptr NewI09
@@4:      cmp GotAck, 1
          je @@OK
          cmp GotErr, 1
          je @@5
         loop @@4
@@5:    dec Yritys
        jnz @@1

        cmp GotAck, 1
        je @@OK

        mov x, 1

@@OK:   mov ax, x
        or ax, ax
        exit

OldIsKb db ?

SetLEDs:arg Field, word, 1
        entry far

        push es
         mov ax, 40h
         mov es, ax
         or byte ptr es:[97h], 40h

         push 0EDh
         push cs
         call near ptr WriteKBD
         jnz @@ERR

         push Field
         push cs
         call near ptr WriteKBD
         mov Field, ax
         jz @@OK

@@ERR:   push 0F4h
         push cs
         call near ptr WriteKBD
         mov Field, 1

@@OK:    and byte ptr es:[97h], not 40h
        pop es

        mov ax, Field
        sti
        exit

WaitRetrace:
        mov dx,3DAh
      @@vert1:
        in al,dx
        test al,8
        jz @@vert1
      @@vert2:
        in al,dx
        test al,8
        jnz @@vert2
        retf

ABSOLUTE:
	pop	ax
	pop	dx
	pop	bx
	push	dx
	push	ax
        push    b$seg
        push    word ptr [bx]
	retf

F_PADD@:; Used by Borland C++
        ;In:   dx:ax = ptr1,
        ;      cx:bx = dword
        ;Adds a longint to a pointer.

        add ax, bx
        jnc @@1
        add dx, 1000h
@@1:    shl cx, 12
        add dx, cx

        mov bx, ax
        and ax, 15
        shr bx, 4
        add dx, bx

        retf
F_PADA@:
        push ds
         push si
          mov ds, dx
          mov si, ax
          mov ax, ds:[si]
          mov dx, ds:[si+2]
          call far ptr F_PADD@
          mov ds:[si], ax
          mov ds:[si+2], dx
         pop si
        pop ds
        retf          
F_LXLSH@:
        push ebx
         mov bx, dx
         shl ebx, 16
         mov bx, ax
         shl ebx, cl
         mov ax, bx
         shr ebx, 16
         mov dx, bx
        pop ebx
        retf

end
